import { RustbinConfig } from '@metaplex-foundation/rustbin';
import { Serializers, TypeAliases } from '../types';
export { RustbinConfig };
export declare type SolitaConfigBase = {
    programName: string;
    idlDir: string;
    sdkDir: string;
    binaryInstallDir: string;
    programDir: string;
    rustbin?: RustbinConfig;
    typeAliases?: TypeAliases;
    serializers?: Serializers;
};
export declare type SolitaConfigAnchor = SolitaConfigBase & {
    idlGenerator: 'anchor';
    programId: string;
};
export declare type SolitaConfigShank = SolitaConfigBase & {
    idlGenerator: 'shank';
};
export declare type SolitaConfig = SolitaConfigAnchor | SolitaConfigShank;
export declare function isSolitaConfigAnchor(config: SolitaConfig): config is SolitaConfigAnchor;
export declare function isSolitaConfigShank(config: SolitaConfig): config is SolitaConfigShank;
